# SpaceMissions

Welcome to SpaceMissions gem! This gem scrapes the NASA JPL (National Aeronautics and Space Administration, Jet Propulsion Laboratory) site that lists its missions, past, present and future!

You can use this gem to see a list of missions, pick any mission for more information, or search missions by target, description, status or launch date.

There's a lot of space exploration going on out there. Enjoy yourself!

Here is a map of how the code flows:
https://www.draw.io/#G1kTJV3IdZMrHr_OBRAEg7t85lNHmaL0l8


Here are some blog posts I wrote about building this project:

Blog post: Flatiron Week 4: creating my own Ruby gem: a tale of fear and Git
https://medium.com/me/stats/post/a0103dc6a6e7

Blog post: CLI Gem Part Two: Scope and Flow!
https://medium.com/p/5a56b6190fa7/edit



Possible future features:
-refine secondary search results


## Installation

Add this line to your application's Gemfile:

```ruby
gem 'space_missions'
```

And then execute:

    $ bundle

Or install it yourself as:

    $ gem install space_missions

## Usage

Once installed, you can run the gem with: ./bin/space_missions
You will be presented with a list of current JPL space missions and instructions on how to proceed.
Have fun checking JPL's many ongoing missions!

## Development

After checking out the repo, run `bin/setup` to install dependencies. Then, run `rake spec` to run the tests. You can also run `bin/console` for an interactive prompt that will allow you to experiment.

To install this gem onto your local machine, run `bundle exec rake install`. To release a new version, update the version number in `version.rb`, and then run `bundle exec rake release`, which will create a git tag for the version, push git commits and tags, and push the `.gem` file to [rubygems.org](https://rubygems.org).

## Contributing

Bug reports and pull requests are welcome on GitHub at https://github.com/[USERNAME]/space_missions. This project is intended to be a safe, welcoming space for collaboration, and contributors are expected to adhere to the [Contributor Covenant](http://contributor-covenant.org) code of conduct.

## License

The gem is available as open source under the terms of the [MIT License](https://opensource.org/licenses/MIT).

## Code of Conduct

Everyone interacting in the SpaceMissions project’s codebases, issue trackers, chat rooms and mailing lists is expected to follow the [code of conduct](https://github.com/[USERNAME]/space_missions/blob/master/CODE_OF_CONDUCT.md).
